#include "vector3.h"
#include "quaternion.h"
#include <list>

#define HISTORY_SIZE 5
#define HISTORY_WEIGHT .4

class UserCamera {
    private:
        quaternion mDesiredOrientation;
        quaternion mCurrentOrientation;

        vector3 mUp;
        vector3 mRight;
        vector3 mForward;

        vector3 mPos;

        double mSpeed;

        bool mMovingForward;
        bool mMovingBackward;
        bool mMovingRight;
        bool mMovingLeft;
        bool mMovingUp;
        bool mMovingDown;
    public:
        UserCamera();
        UserCamera(vector3 p, vector3 d);
        ~UserCamera();

        void beginForward();
        void beginLeft();
        void beginRight();
        void beginBackward();
        void beginUp();
        void beginDown();

        void endForward();
        void endLeft();
        void endRight();
        void endBackward();
        void endUp();
        void endDown();

        void rotateAboutRight(double angle);
        void rotateAboutUp(double angle);
        void rotateAboutForward(double angle);

        vector3 getPosition();

        void update(double dt);
        void apply();
        void debug();
};
